Index: main/trunk/greenstone2/common-src/indexers/mg/lib/huffman_stdio.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/huffman_stdio.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/huffman_stdio.h	(revision 25147)
@@ -25,10 +25,10 @@
 
 
-void BIO_Stdio_Huff_Encode (unsigned long val, unsigned long *codes,
+void BIO_Stdio_Huff_Encode (mg_u_long val, mg_u_long *codes,
 			    char *clens, stdio_bitio_state * bs);
 
 
-unsigned long BIO_Stdio_Huff_Decode (unsigned long *mincodes,
-				     unsigned long **values,
+mg_u_long BIO_Stdio_Huff_Decode (mg_u_long *mincodes,
+				     mg_u_long **values,
 				     stdio_bitio_state * bs);
 
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/longlong.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/longlong.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/longlong.h	(revision 25147)
@@ -22,4 +22,6 @@
 #ifndef H_LONGLONG
 #define H_LONGLONG
+
+#include "mglong.h"
 
 #ifndef __WIN32__
@@ -71,9 +73,9 @@
 
 /* Not using GCC, so fall back on plain "long" (32-bit) types */
-typedef unsigned long int mg_ullong;
-typedef long int mg_llong;
+typedef uint32_t mg_ullong;
+typedef int32_t mg_llong;
 
-#define ULL_FS "lu"
-#define LL_FS "ld"
+#define ULL_FS "u"
+#define LL_FS "d"
 
 #endif /* __GNUC__ */
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/messages.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/messages.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/messages.c	(revision 25147)
@@ -28,5 +28,5 @@
 
 
-void VOLATILE 
+void
 FatalError (int ExitCode, const char *fmt,...)
 {
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/messages.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/messages.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/messages.h	(revision 25147)
@@ -31,5 +31,5 @@
 extern char *msg_prefix;
 
-void VOLATILE FatalError (int ExitCode, const char *fmt,...);
+void FatalError (int ExitCode, const char *fmt,...);
 
 void Message (const char *fmt,...);
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/mglong.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/mglong.h	(revision 25147)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/mglong.h	(revision 25147)
@@ -0,0 +1,14 @@
+#ifndef MGLONG_H
+#define MGLONG_H
+
+#include <stdint.h>
+
+#ifndef mg_u_long
+#define mg_u_long uint32_t
+#endif
+
+#ifndef mg_s_long
+#define mg_s_long int32_t
+#endif
+
+#endif
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/netorder.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/netorder.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/netorder.h	(revision 25147)
@@ -17,5 +17,5 @@
 #define HTOND(d)                                                                                  \
         do {                                                                                      \
-             unsigned long tmph, tmpl;                                                            \
+             mg_u_long tmph, tmpl;                                                            \
 	     bcopy ((char *) &d, (char *) &tmph, sizeof(double) >> 1);                            \
 	     bcopy ((char *) &d + (sizeof(double) >> 1), (char *) &tmpl, sizeof (double) >> 1);   \
@@ -27,5 +27,5 @@
 #define NTOHD(d)                                                                                  \
         do {                                                                                      \
-             unsigned long tmph, tmpl;                                                            \
+             mg_u_long tmph, tmpl;                                                            \
 	     bcopy ((char *) &d, (char *) &tmph, sizeof(double) >> 1);                            \
 	     bcopy ((char *) &d + (sizeof(double) >> 1), (char *) &tmpl, sizeof (double) >> 1);   \
@@ -37,5 +37,5 @@
 #define HTOND2(hd, nd)                                                                            \
         do {                                                                                      \
-             unsigned long tmph, tmpl;                                                            \
+             mg_u_long tmph, tmpl;                                                            \
 	     bcopy ((char *) &hd, (char *) &tmph, sizeof(double) >> 1);                           \
 	     bcopy ((char *) &hd + (sizeof(double) >> 1), (char *) &tmpl, sizeof (double) >> 1);  \
@@ -47,5 +47,5 @@
 #define NTOHD2(nd, hd)                                                                            \
         do {                                                                                      \
-             unsigned long tmph, tmpl;                                                            \
+             mg_u_long tmph, tmpl;                                                            \
 	     bcopy ((char *) &nd, (char *) &tmph, sizeof(double) >> 1);                           \
 	     bcopy ((char *) &nd + (sizeof(double) >> 1), (char *) &tmpl, sizeof (double) >> 1);  \
@@ -59,5 +59,5 @@
 #define HTONF(f)                                                                   \
         do {                                                                       \
-             unsigned long tmp;                                                    \
+             mg_u_long tmp;                                                    \
              bcopy ((char *) &(f), (char *) &tmp, sizeof (float));                 \
              HTONUL (tmp);                                                         \
@@ -66,5 +66,5 @@
 #define NTOHF(f)                                                                   \
         do {                                                                       \
-             unsigned long tmp;                                                    \
+             mg_u_long tmp;                                                    \
              bcopy ((char *) &(f), (char *) &tmp, sizeof (float));                 \
 	     NTOHUL (tmp);                                                         \
@@ -73,5 +73,5 @@
 #define HTONF2(hf, nf)                                                             \
         do {                                                                       \
-             unsigned long tmp;                                                    \
+             mg_u_long tmp;                                                    \
              bcopy ((char *) &(hf), (char *) &tmp, sizeof (float));                \
              HTONUL (tmp);                                                         \
@@ -80,5 +80,5 @@
 #define NTOHF2(nf, hf)                                                             \
         do {                                                                       \
-             unsigned long tmp;                                                    \
+             mg_u_long tmp;                                                    \
              bcopy ((char *) &(nf), (char *) &tmp, sizeof (float));                \
 	     NTOHUL (tmp);                                                         \
@@ -115,8 +115,8 @@
 
 /* pointers */
-#define HTONP(p)          ((p) = (void *) htonl ((unsigned long) p))
-#define NTOHP(p)          ((p) = (void *) ntohl ((unsigned long) p))
-#define HTONP2(hp, np)    ((np) = (void *) htonl ((unsigned long) hp))
-#define NTOHP2(np, hp)    ((hp) = (void *) ntohl ((unsigned long) np))
+#define HTONP(p)          ((p) = (void *) htonl ((mg_u_long) p))
+#define NTOHP(p)          ((p) = (void *) ntohl ((mg_u_long) p))
+#define HTONP2(hp, np)    ((np) = (void *) htonl ((mg_u_long) hp))
+#define NTOHP2(np, hp)    ((hp) = (void *) ntohl ((mg_u_long) np))
 
 /* unsigned long */
@@ -127,20 +127,20 @@
 
 /* signed long */
-#define HTONSL(l)         ((l) = (long) htonl ((unsigned long) (l)))
-#define NTOHSL(l)         ((l) = (long) ntohl ((unsigned long) (l)))
-#define HTONSL2(hl, nl)   ((nl) = (long) htonl ((unsigned long) (hl)))
-#define NTOHSL2(nl, hl)   ((hl) = (long) ntohl ((unsigned long) (nl)))
+#define HTONSL(l)         ((l) = (mg_s_long) htonl ((mg_u_long) (l)))
+#define NTOHSL(l)         ((l) = (mg_s_long) ntohl ((mg_u_long) (l)))
+#define HTONSL2(hl, nl)   ((nl) = (mg_s_long) htonl ((mg_u_long) (hl)))
+#define NTOHSL2(nl, hl)   ((hl) = (mg_s_long) ntohl ((mg_u_long) (nl)))
 
 /* unsigned int */
-#define HTONUI(i)         ((i) = (unsigned int) htonl ((unsigned long) (i)))
-#define NTOHUI(i)         ((i) = (unsigned int) ntohl ((unsigned long) (i)))
-#define HTONUI2(hi, ni)   ((ni) = (unsigned int) htonl ((unsigned long) (hi)))
-#define NTOHUI2(ni, hi)   ((hi) = (unsigned int) ntohl ((unsigned long) (ni)))
+#define HTONUI(i)         ((i) = (unsigned int) htonl ((mg_u_long) (i)))
+#define NTOHUI(i)         ((i) = (unsigned int) ntohl ((mg_u_long) (i)))
+#define HTONUI2(hi, ni)   ((ni) = (unsigned int) htonl ((mg_u_long) (hi)))
+#define NTOHUI2(ni, hi)   ((hi) = (unsigned int) ntohl ((mg_u_long) (ni)))
 
 /* signed int */
-#define HTONSI(i)         ((i) = (int) htonl ((unsigned long) (i)))
-#define NTOHSI(i)         ((i) = (int) ntohl ((unsigned long) (i)))
-#define HTONSI2(hi, ni)   ((ni) = (int) htonl ((unsigned long) (hi)))
-#define NTOHSI2(ni, hi)   ((hi) = (int) ntohl ((unsigned long) (ni)))
+#define HTONSI(i)         ((i) = (int) htonl ((mg_u_long) (i)))
+#define NTOHSI(i)         ((i) = (int) ntohl ((mg_u_long) (i)))
+#define HTONSI2(hi, ni)   ((ni) = (int) htonl ((mg_u_long) (hi)))
+#define NTOHSI2(ni, hi)   ((hi) = (int) ntohl ((mg_u_long) (ni)))
 
 /* unsigned short */
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.c	(revision 25147)
@@ -42,5 +42,5 @@
 
 /* Random Number stuff */
-static long seed[] = {0, 0};
+static mg_s_long seed[] = {0, 0};
 #define RANDOM() irandm(seed)
 #define SEED_RANDOM(the_seed) do{ seed[0] = the_seed; }while(0)
@@ -105,5 +105,5 @@
 
 #ifndef STRUCT
-static long **tb0, **tb1, **tb2;
+static mg_s_long **tb0, **tb1, **tb2;
 #else
 struct tb_entry **tb;
@@ -128,6 +128,5 @@
 {				/* deletes edge e from list of v */
 
-  int b;
-
+  int b, norm_b;
   b = FIRST[v];
   assert (norm (b) != 0);
@@ -700,11 +699,11 @@
     {
       if (tb0)
-	if (!(tb0[i] = Xmalloc (sizeof (long) * MAX_L)))
+	if (!(tb0[i] = Xmalloc (sizeof (mg_s_long) * MAX_L)))
 	    ok = 0;
       if (tb1)
-	if (!(tb1[i] = Xmalloc (sizeof (long) * MAX_L)))
+	if (!(tb1[i] = Xmalloc (sizeof (mg_s_long) * MAX_L)))
 	    ok = 0;
       if (tb2)
-	if (!(tb2[i] = Xmalloc (sizeof (long) * MAX_L)))
+	if (!(tb2[i] = Xmalloc (sizeof (mg_s_long) * MAX_L)))
 	    ok = 0;
     }
@@ -744,5 +743,5 @@
 
   if (r <= 0)
-    SEED_RANDOM ((long) time ((time_t *) NULL));
+    SEED_RANDOM ((mg_s_long) time ((time_t *) NULL));
   else
     SEED_RANDOM (r);
@@ -907,11 +906,11 @@
     {
       if (phd->tb0)
-	if (!(phd->tb0[i] = Xmalloc (sizeof (long) * phd->MAX_L)))
+	if (!(phd->tb0[i] = Xmalloc (sizeof (mg_s_long) * phd->MAX_L)))
 	    ok = 0;
       if (phd->tb1)
-	if (!(phd->tb1[i] = Xmalloc (sizeof (long) * phd->MAX_L)))
+	if (!(phd->tb1[i] = Xmalloc (sizeof (mg_s_long) * phd->MAX_L)))
 	    ok = 0;
       if (phd->tb2)
-	if (!(phd->tb2[i] = Xmalloc (sizeof (long) * phd->MAX_L)))
+	if (!(phd->tb2[i] = Xmalloc (sizeof (mg_s_long) * phd->MAX_L)))
 	    ok = 0;
     }
@@ -951,9 +950,9 @@
       int j;
 
-      tot += fread ((char *) phd->tb0[i], sizeof (long), phd->MAX_L, f) *
+      tot += fread ((char *) phd->tb0[i], sizeof (mg_s_long), phd->MAX_L, f) *
         sizeof (int);
-      tot += fread ((char *) phd->tb1[i], sizeof (long), phd->MAX_L, f) *
+      tot += fread ((char *) phd->tb1[i], sizeof (mg_s_long), phd->MAX_L, f) *
         sizeof (int);
-      tot += fread ((char *) phd->tb2[i], sizeof (long), phd->MAX_L, f) *
+      tot += fread ((char *) phd->tb2[i], sizeof (mg_s_long), phd->MAX_L, f) *
         sizeof (int);
 
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/perf_hash.h	(revision 25147)
@@ -23,10 +23,9 @@
 #define H_PERF_HASH
 
-
-
+#include "mglong.h"
 
 struct tb_entry
   {
-    long tb0, tb1, tb2;
+    mg_s_long tb0, tb1, tb2;
   };
 
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/random.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/random.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/random.c	(revision 25147)
@@ -33,6 +33,7 @@
  *	The table mt[0:127] is defined by mt[i] = 69069 ** (128-i)
  */
-
-#define MASK ((long) 593970775)
+#include "random.h"
+
+#define MASK ((mg_s_long) 593970775)
 /*	or in hex, 23674657	*/
 
@@ -40,5 +41,5 @@
 /*	i.e. 2 to power -31	*/
 
-static long mt [128] =   {
+static mg_s_long mt [128] =   {
       902906369,
      2030498053,
@@ -172,7 +173,7 @@
 
 double 
-random (long is [2])
+random (mg_s_long is [2])
 {
-	long it, leh, nit;
+	mg_s_long it, leh, nit;
 
 	it = is [0];
@@ -187,13 +188,13 @@
 	is [0] = it;    is [1] = leh;
 	if (leh < 0) leh = ~leh;
-	return (SCALE * ((long) (leh | 1)));
+	return (SCALE * ((mg_s_long) (leh | 1)));
 }
 
 
 
-long 
-irandm (long is [2])
+mg_s_long 
+irandm (mg_s_long is [2])
 {
-	long it, leh, nit;
+	mg_s_long it, leh, nit;
 
 	it = is [0];
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/random.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/random.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/random.h	(revision 25147)
@@ -36,7 +36,8 @@
  *	The table mt[0:127] is defined by mt[i] = 69069 ** (128-i)
  */
+#include "mglong.h"
 
-double random (long is [2]);
-long irandm (long is [2]);
+double random (mg_s_long is [2]);
+mg_s_long irandm (mg_s_long is [2]);
 
 #endif
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/regex.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/regex.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/regex.c	(revision 25147)
@@ -2896,5 +2896,5 @@
   register char *fastmap = bufp->fastmap;
   unsigned char *pattern = bufp->buffer;
-  unsigned long size = bufp->used;
+  mg_u_long size = bufp->used;
   unsigned char *p = pattern;
   register unsigned char *pend = pattern + size;
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/regex.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/regex.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/regex.h	(revision 25147)
@@ -292,8 +292,8 @@
 
 	/* Number of bytes to which `buffer' points.  */
-  unsigned long allocated;
+  mg_u_long allocated;
 
 	/* Number of bytes actually used in `buffer'.  */
-  unsigned long used;	
+  mg_u_long used;	
 
         /* Syntax setting with which the pattern was compiled.  */
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/rx.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/rx.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/rx.c	(revision 25147)
@@ -615,8 +615,8 @@
 
 #ifdef __STDC__
-RX_DECL unsigned long
+RX_DECL mg_u_long
 rx_bitset_hash (int size, rx_Bitset b)
 #else
-RX_DECL unsigned long
+RX_DECL mg_u_long
 rx_bitset_hash (size, b)
      int size;
@@ -625,5 +625,5 @@
 {
   int x;
-  unsigned long hash = (unsigned long)rx_bitset_hash;
+  uintptr_t hash = (uintptr_t)rx_bitset_hash;
 
   for (x = rx_bitset_numb_subsets(size) - 1; x >= 0; --x)
@@ -701,5 +701,5 @@
 
 
-static unsigned long rx_hash_masks[4] =
+static mg_u_long rx_hash_masks[4] =
 {
   0x12488421,
@@ -714,5 +714,5 @@
 RX_DECL struct rx_hash_item * 
 rx_hash_find (struct rx_hash * table,
-	      unsigned long hash,
+	      mg_u_long hash,
 	      void * value,
 	      struct rx_hash_rules * rules)
@@ -721,5 +721,5 @@
 rx_hash_find (table, hash, value, rules)
      struct rx_hash * table;
-     unsigned long hash;
+     mg_u_long hash;
      void * value;
      struct rx_hash_rules * rules;
@@ -728,5 +728,5 @@
   rx_hash_eq eq = rules->eq;
   int maskc = 0;
-  long mask = rx_hash_masks [0];
+  mg_s_long mask = rx_hash_masks [0];
   int bucket = (hash & mask) % 13;
 
@@ -755,5 +755,5 @@
 RX_DECL struct rx_hash_item *
 rx_hash_store (struct rx_hash * table,
-	       unsigned long hash,
+	       mg_u_long hash,
 	       void * value,
 	       struct rx_hash_rules * rules)
@@ -762,5 +762,5 @@
 rx_hash_store (table, hash, value, rules)
      struct rx_hash * table;
-     unsigned long hash;
+     mg_u_long hash;
      void * value;
      struct rx_hash_rules * rules;
@@ -769,5 +769,5 @@
   rx_hash_eq eq = rules->eq;
   int maskc = 0;
-  long mask = rx_hash_masks[0];
+  mg_s_long mask = rx_hash_masks[0];
   int bucket = (hash & mask) % 13;
   int depth = 0;
@@ -803,5 +803,5 @@
 	{
 	  struct rx_hash_item * them = table->buckets[bucket];
-	  unsigned long newmask = rx_hash_masks[maskc + 1];
+	  mg_u_long newmask = rx_hash_masks[maskc + 1];
 	  while (them)
 	    {
@@ -855,5 +855,5 @@
     {
       struct rx_hash * table = it->table;
-      unsigned long hash = it->hash;
+      mg_u_long hash = it->hash;
       int depth = (table->parent
 		   ? (table->parent->parent
@@ -1775,7 +1775,7 @@
 	     : (!vb
 		? 1
-		: ((long)a->car < (long)b->car
+		: ((intptr_t)a->car < (intptr_t)b->car
 		   ? 1
-		   : ((long)a->car > (long)b->car
+		   : ((intptr_t)a->car > (intptr_t)b->car
 		      ? -1
 		      : se_list_cmp ((void *)a->cdr, (void *)b->cdr))))));
@@ -1842,5 +1842,5 @@
 #endif
 {
-  long hash = (long)car ^ (long)cdr;
+  intptr_t hash = (intptr_t)car ^ (intptr_t)cdr;
   struct rx_se_list template;
 
@@ -1955,5 +1955,5 @@
   template.cdr = set;
   node = rx_hash_store (memo,
-			(((long)state) >> 8) ^ (long)set,
+			(((intptr_t)state) >> 8) ^ (intptr_t)set,
 			&template, &nfa_set_hash_rules);
   if (!node)
@@ -2264,5 +2264,5 @@
 RX_DECL int 
 rx_compactify_nfa (struct rx *rx,
-		   void **mem, unsigned long *size)
+		   void **mem, mg_u_long *size)
 #else
 RX_DECL int 
@@ -2270,5 +2270,5 @@
      struct rx *rx;
      void **mem;
-     unsigned long *size;
+     mg_u_long *size;
 #endif
 {
@@ -2279,5 +2279,5 @@
   int se_list_consc = count_hash_nodes (&rx->se_list_memo);
   int nfa_setc = count_hash_nodes (&rx->set_list_memo);
-  unsigned long total_size;
+  mg_u_long total_size;
 
   /* This takes place in two stages.   First, the total size of the
@@ -2407,5 +2407,5 @@
 	      {
 		sp = rx_hash_find (&rx->se_list_memo,
-				   (long)sesrc->car ^ (long)sesrc->cdr,
+				   (intptr_t)sesrc->car ^ (intptr_t)sesrc->cdr,
 				   sesrc, &se_list_hash_rules);
 		if (sp->binding)
@@ -2425,6 +2425,6 @@
 	      {
 		sp = rx_hash_find (&rx->set_list_memo,
-				   ((((long)destlst->car) >> 8)
-				    ^ (long)destlst->cdr),
+				   ((((intptr_t)destlst->car) >> 8)
+				    ^ (intptr_t)destlst->cdr),
 				   destlst, &nfa_set_hash_rules);
 		if (sp->binding)
@@ -2798,5 +2798,5 @@
 	(rx_hash_find
 	 (&cache->superset_table,
-	  (unsigned long)set->car ^ set->id ^ (unsigned long)set->cdr,
+	  (intptr_t)set->car ^ set->id ^ (intptr_t)set->cdr,
 	  (void *)set,
 	  &cache->superset_hash_rules),
@@ -3056,5 +3056,5 @@
     = ((struct rx_cache *)
        ((char *)rules
-	- (unsigned long)(&((struct rx_cache *)0)->superset_hash_rules)));
+	- (intptr_t)(&((struct rx_cache *)0)->superset_hash_rules)));
   struct rx_superset * template = (struct rx_superset *)val;
   struct rx_superset * newset
@@ -3088,5 +3088,5 @@
     = ((struct rx_cache *)
        ((char *)rules
-	- (unsigned long)(&((struct rx_cache *)0)->superset_hash_rules)));
+	- (intptr_t)(&((struct rx_cache *)0)->superset_hash_rules)));
   return ((struct rx_hash *)
 	  rx_cache_malloc_or_get (cache,
@@ -3107,5 +3107,5 @@
   struct rx_cache * cache
     = ((struct rx_cache *)
-       (char *)rules - (long)(&((struct rx_cache *)0)->superset_hash_rules));
+       (char *)rules - (intptr_t)(&((struct rx_cache *)0)->superset_hash_rules));
   rx_cache_free (cache, &cache->free_hash, (char *)hash);
 }
@@ -3264,5 +3264,5 @@
     template.id = car->id;
     hit = rx_hash_store (&cache->superset_table,
-			 (unsigned long)car ^ car->id ^ (unsigned long)cdr,
+			 (intptr_t)car ^ car->id ^ (intptr_t)cdr,
 			 (void *)&template,
 			 &cache->superset_hash_rules);
@@ -4332,7 +4332,7 @@
 	return;
       case r_side_effect:
-	if (   ((long)rexp->params.side_effect >= 0)
-	    && (params [(long)rexp->params.side_effect].se == re_se_backref))
-	  out[ params [(long)rexp->params.side_effect].op1] = 1;
+	if (   ((intptr_t)rexp->params.side_effect >= 0)
+	    && (params [(intptr_t)rexp->params.side_effect].se == re_se_backref))
+	  out[ params [(intptr_t)rexp->params.side_effect].op1] = 1;
 	return;
       }
@@ -4516,5 +4516,5 @@
       case r_side_effect:
 	{
-	  int se = (long)rexp->params.side_effect;
+	  int se = (intptr_t)rexp->params.side_effect;
 	  if (   (se >= 0)
 	      && (   ((enum re_side_effects)params[se].se == re_se_lparen)
@@ -4563,7 +4563,7 @@
       return pointless_if_repeated (node->params.pair.left, params);
     case r_side_effect:
-      switch ((enum re_side_effects) (((long)node->params.side_effect < 0)
-	      ? (enum re_side_effects) (long) node->params.side_effect
-	      : (enum re_side_effects)params[(long)node->params.side_effect].se))
+      switch ((enum re_side_effects) (((intptr_t)node->params.side_effect < 0)
+	      ? (enum re_side_effects) (intptr_t) node->params.side_effect
+	      : (enum re_side_effects)params[(intptr_t)node->params.side_effect].se))
 	{
 	case re_se_try:
@@ -4588,4 +4588,12 @@
 	case re_se_backref:
 	  return 0;
+	case re_se_pushback:
+	case re_se_push0:
+	case re_se_pushpos:
+	case re_se_chkpos:
+	case re_se_poppos:
+	case re_se_tv:
+	case re_floogle_flap:
+	  return -1;
 	}
     case r_data:
@@ -4637,5 +4645,5 @@
       case r_side_effect:
 	{
-	  int se = (long)rexp->params.side_effect;
+	  int se = (intptr_t)rexp->params.side_effect;
 	  if (   in_danger
 	      && (se >= 0)
@@ -4757,7 +4765,7 @@
     case r_side_effect:
       return
-	!((long)rexp->params.side_effect > 0
-	  ? idempotent_complex_se [ params [(long)rexp->params.side_effect].se ]
-	  : idempotent_se [-(long)rexp->params.side_effect]);
+	!((intptr_t)rexp->params.side_effect > 0
+	  ? idempotent_complex_se [ params [(intptr_t)rexp->params.side_effect].se ]
+	  : idempotent_se [-(intptr_t)rexp->params.side_effect]);
       
     case r_alternate:
@@ -4811,5 +4819,5 @@
 
     case r_side_effect:
-      return ((long)rexp->params.side_effect >= 0);
+      return ((intptr_t)rexp->params.side_effect >= 0);
       
     case r_alternate:
@@ -5204,5 +5212,5 @@
 	      if (need_sync)
 		{
-		  int sync_se = paramc;
+		  intptr_t sync_se = paramc;
 		  params = (params
 			    ? ((struct re_se_params *)
@@ -5552,9 +5560,12 @@
             handle_close:
               /* See similar code for backslashed left paren above.  */
-              if (COMPILE_STACK_EMPTY)
-                if (syntax & RE_UNMATCHED_RIGHT_PAREN_ORD)
+              if (COMPILE_STACK_EMPTY){
+                if (syntax & RE_UNMATCHED_RIGHT_PAREN_ORD){
                   goto normal_char;
-                else
+		}
+                else{
                   return REG_ERPAREN;
+		}
+	      }
 
               /* Since we just checked for an empty stack above, this
@@ -5573,6 +5584,6 @@
                 this_group_regnum = COMPILE_STACK_TOP.regnum;
 		{
-		  int left_se = paramc;
-		  int right_se = paramc + 1;
+		  intptr_t left_se = paramc;
+		  intptr_t right_se = paramc + 1;
 
 		  params = (params
@@ -5625,5 +5636,5 @@
 		last_expression = &alt->params.pair.right;
 		{
-		  int sync_se = paramc;
+		  intptr_t sync_se = paramc;
 
 		  params = (params
@@ -5742,6 +5753,6 @@
 		  /* Otherwise, we have a nontrivial interval. */
 		  {
-		    int iter_se = paramc;
-		    int end_se = paramc + 1;
+		    intptr_t iter_se = paramc;
+		    intptr_t end_se = paramc + 1;
 		    params = (params
 			      ? ((struct re_se_params *)
@@ -5939,5 +5950,5 @@
 
 	      {
-		int backref_se = paramc;
+		intptr_t backref_se = paramc;
 		params = (params
 			  ? ((struct re_se_params *)
@@ -6009,5 +6020,5 @@
   
   {
-    int win_se = paramc;
+    intptr_t win_se = paramc;
     params = (params
 	      ? ((struct re_se_params *)
@@ -6149,5 +6160,5 @@
       {
 	void * mem = (void *)rxb->buffer;
-	unsigned long size = rxb->allocated;
+	mg_u_long size = rxb->allocated;
 	int start_id;
 	char * perm_mem;
@@ -6757,5 +6768,5 @@
   while (list)
     {
-      if ((long)list->car >= 0)
+      if ((intptr_t)list->car >= 0)
 	++x;
       list = list->cdr;
@@ -6812,5 +6823,5 @@
       for (ai = al - 1; ai >= 0; --ai)
 	{
-	  while ((long)ap->car < 0)
+	  while ((intptr_t)ap->car < 0)
 	    ap = ap->cdr;
 	  av[ai] = ap->car;
@@ -6820,5 +6831,5 @@
       for (bi = bl - 1; bi >= 0; --bi)
 	{
-	  while ((long)bp->car < 0)
+	  while ((intptr_t)bp->car < 0)
 	    bp = bp->cdr;
 	  bv[bi] = bp->car;
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/rx.h
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/rx.h	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/rx.h	(revision 25147)
@@ -22,11 +22,5 @@
 /*  t. lord	Wed Sep 23 18:20:57 1992	*/
 
-
-
-
-
-
-
-
+#include "mglong.h"
 
 #ifndef RX_WANT_SE_DEFS
@@ -91,5 +85,5 @@
   struct rx_hash_item * next_same_hash;
   struct rx_hash * table;
-  unsigned long hash;
+  mg_u_long hash;
   void * data;
   void * binding;
@@ -273,5 +267,5 @@
    */
   void * buffer;
-  unsigned long allocated;
+  mg_u_long allocated;
 
   /* Clients of RX can ask for some extra storage in the space pointed
@@ -280,5 +274,5 @@
    * at (buffer + allocated - reserved)
    */
-  unsigned long reserved;
+  mg_u_long reserved;
 
   /* --------- The remaining fields are for internal use only. --------- */
@@ -1274,5 +1268,5 @@
 
   void * buffer;		/* Malloced memory for the nfa. */
-  unsigned long allocated;	/* Size of that memory. */
+  mg_u_long allocated;	/* Size of that memory. */
 
   /* Pointer to a fastmap, if any, otherwise zero.  re_search uses
@@ -1580,11 +1574,11 @@
 				      rx_Bitset a, rx_Bitset b);
 RX_DECL void rx_bitset_xor (int size, rx_Bitset a, rx_Bitset b);
-RX_DECL unsigned long rx_bitset_hash (int size, rx_Bitset b);
+RX_DECL mg_u_long rx_bitset_hash (int size, rx_Bitset b);
 RX_DECL struct rx_hash_item * rx_hash_find (struct rx_hash * table,
-					    unsigned long hash,
+					    mg_u_long hash,
 					    void * value,
 					    struct rx_hash_rules * rules);
 RX_DECL struct rx_hash_item * rx_hash_store (struct rx_hash * table,
-					     unsigned long hash,
+					     mg_u_long hash,
 					     void * value,
 					     struct rx_hash_rules * rules);
@@ -1637,5 +1631,5 @@
 RX_DECL void rx_delete_epsilon_transitions (struct rx *rx);
 RX_DECL int rx_compactify_nfa (struct rx *rx,
-			       void **mem, unsigned long *size);
+			       void **mem, mg_u_long *size);
 RX_DECL void rx_release_superset (struct rx *rx,
 				  struct rx_superset *set);
@@ -1665,5 +1659,5 @@
 RX_DECL void rx_bitset_revdifference ();
 RX_DECL void rx_bitset_xor ();
-RX_DECL unsigned long rx_bitset_hash ();
+RX_DECL mg_u_long rx_bitset_hash ();
 RX_DECL struct rx_hash_item * rx_hash_find ();
 RX_DECL struct rx_hash_item * rx_hash_store ();
@@ -2230,5 +2224,4 @@
 
 
-
 /* How many characters in the character set.  */
 #define CHAR_SET_SIZE (1 << CHARBITS)
@@ -2344,5 +2337,5 @@
 RX_DECL __inline__ int
 rx_search  (struct re_pattern_buffer * rxb,
-	    int startpos,
+	    intptr_t startpos,
 	    int range,
 	    int stop,
@@ -2361,5 +2354,5 @@
 	    app_closure, regs, resume_state, save_state)
      struct re_pattern_buffer * rxb;
-     int startpos;
+     intptr_t startpos;
      int range;
      int stop;
@@ -2739,5 +2732,5 @@
   {
     enum rx_test_match_entry test_pc;
-    int inx;
+    intptr_t inx;
     test_pc = search_state.test_match_resume_pt;
     if (test_pc == rx_test_start)
@@ -2839,5 +2832,5 @@
 		    ((struct rx_superstate *)
 		     ((char *)this_tr_table
-		      - ((unsigned long)
+		      - ((mg_u_long)
 			 ((struct rx_superstate *)0)->transitions)));
 		  
@@ -2904,5 +2897,5 @@
 	    ((struct rx_superstate *)
 	     ((char *)this_tr_table
-	      - ((unsigned long)
+	      - ((uintptr_t)
 		 ((struct rx_superstate *)0)->transitions)));
 	}
@@ -2911,5 +2904,5 @@
 	 * Dispatch that instruction:
 	 */
-	inx = (int)search_state.ifr->inx;
+	inx = (intptr_t)search_state.ifr->inx;
 #ifdef RX_DEBUG_0
 	if (rx_debug_trace)
@@ -2949,6 +2942,6 @@
 	      while (el)
 		{
-		  long effect;
-		  effect = (long)el->car;
+		  intptr_t effect;
+		  effect = (intptr_t)el->car;
 		  if (effect < 0)
 		    {
@@ -2990,5 +2983,5 @@
 			    = ((struct rx_superstate *)
 			       ((char *)search_state.ifr->data
-				- (long)(((struct rx_superstate *)0)
+				- (intptr_t)(((struct rx_superstate *)0)
 					 ->transitions)));
 			  goto top_of_cycle;
Index: main/trunk/greenstone2/common-src/indexers/mg/lib/sptree.c
===================================================================
--- main/trunk/greenstone2/common-src/indexers/mg/lib/sptree.c	(revision 23431)
+++ main/trunk/greenstone2/common-src/indexers/mg/lib/sptree.c	(revision 25147)
@@ -293,12 +293,16 @@
 		q->par = p;				\
 		q->rght = p->left;			\
-		if(q->rght)				\
-			q->rght->par = q;		\
+		if(q->rght){				\
+		  q->rght->par = q;			\
+		}                                       \
 		p->left = q;				\
-		if(p->par)				\
-			if(q == p->par->left)		\
-				p->par->left = p;	\
-			else				\
-				p->par->rght = p;	\
+		if(p->par){				\
+		  if(q == p->par->left){		\
+		    p->par->left = p;			\
+		  }                                     \
+		  else{					\
+		    p->par->rght = p;			\
+		  }                                     \
+		}                                       \
 	}while(0)
 
@@ -308,12 +312,16 @@
 		q->par = p;				\
 		q->left = p->rght;			\
-		if(q->left)				\
-			q->left->par = q;		\
+		if(q->left){				\
+		  q->left->par = q;			\
+		}                                       \
 		p->rght = q;				\
-		if(p->par)				\
-			if(q == p->par->left)		\
-				p->par->left = p;	\
-			else				\
-				p->par->rght = p;	\
+		if(p->par){				\
+		  if(q == p->par->left){		\
+		    p->par->left = p;			\
+		  }                                     \
+		  else{		                        \
+		    p->par->rght = p;			\
+		  }                                     \
+		}                                       \
 	}while(0)
 
@@ -341,6 +349,7 @@
       if (p == q->left)
 	{
-	  if (g == NNULL)
+	  if (g == NNULL){
 	    ROTATER (p, q);
+	  }
 	  else if (q == g->left)
 	    {
@@ -356,6 +365,7 @@
       else
 	{
-	  if (g == NNULL)
+	  if (g == NNULL){
 	    ROTATEL (p, q);
+	  }
 	  else if (q == g->rght)
 	    {
